/************************************************************************/
/* TinyTalk utilities.							 */
/* */
/* Version 1.0 [ 1/24/90] : Initial implementation by ABR.		 */
/* 1.1 [ 1/25/90] : Moved terminal control here.		 */
/* 1.2 [ 1/25/90] : Modified to set termcap var 'ospeed'.	 */
/* 1.3 [ 2/ 2/90] : Added comparestr() and hiliting.	 */
/* 1.4 [ 2/ 5/90] : Added expand_filename() for $#@! UNIX. */
/* Disable its fancy stuff because there  */
/* are no shared libraries.		 */
/* */
/************************************************************************/

#include "TinyMUD_copyright.h"
#include "client.h"
#include <sys/ioctl.h>
#include <sgtty.h>
#include <stdio.h>

#ifdef TERMCAP
extern short    ospeed;
#endif

cbreak_noecho_mode()
{				/* When we're running... */
	struct sgttyb   blob;

	if (ioctl(0, TIOCGETP, &blob) == -1)
		perror("TIOCGETP ioctl");
	blob.sg_flags |= CBREAK;
	blob.sg_flags &= ~ECHO;
	if (ioctl(0, TIOCSETP, &blob) == -1)
		perror("TIOCSETP ioctl");
#ifdef TERMCAP
	ospeed = blob.sg_ospeed;
#endif
}

cooked_echo_mode()
{				/* When we exit... */
	struct sgttyb   blob;

	if (ioctl(0, TIOCGETP, &blob) == -1)
		perror("TIOCGETP ioctl");
	blob.sg_flags &= ~CBREAK;
	blob.sg_flags |= ECHO;
	if (ioctl(0, TIOCSETP, &blob) == -1)
		perror("TIOCSETP ioctl");
}

die(why, s1, s2, s3, s4)
	char           *why, *s1, *s2, *s3, *s4;
{
	cooked_echo_mode();	/* Reset terminal characteristics. */
	fprintf(stderr, why, s1, s2, s3, s4);
	exit(1);
}
