/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.c.
 * Restrictions in GB_copyright.h.c.
 * autoreport.c -- tell server to generate a report for each planet
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "buffers.h"

autoreport(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
planettype *p;
placetype place;
int autoreport_pdata,autoreport_sectdata;

if (argn==1) {   /* no args */
 if (Dir[Playernum-1].level==LEVEL_PLAN) {
  openpdata(&autoreport_pdata);
  getplanet(autoreport_pdata,&p,
	Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
  if (p->info[Playernum-1].autorep)
	p->info[Playernum-1].autorep = 0;
  else
	p->info[Playernum-1].autorep = TELEG_MAX_AUTO;

  putplanet(autoreport_pdata, p, 
	Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
  close_file(autoreport_pdata);

  sprintf(buf,"Autoreport on %s has been %s.\n",
	Stars[Dir[Playernum-1].snum]->pnames[Dir[Playernum-1].pnum],
	p->info[Playernum-1].autorep ? "set" : "unset");
  	notify(Playernum, buf);

free(p);
 } else {
	  sprintf(buf,"Scope must be a planet or ship.\n");
	 notify(Playernum, buf);
	  return(1);
   	}
} else if (argn==2) {     /* argn==2, place specified */
  place = Getplace(Playernum,args[1], 0);
  if (place.level==LEVEL_PLAN) {
     openpdata(&autoreport_pdata);
     getplanet(autoreport_pdata,&p,
	Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);

     sprintf(buf,"Autoreport on %s has been %s.\n",
	  Stars[Dir[Playernum-1].snum]->pnames[Dir[Playernum-1].pnum],
	  p->info[Playernum-1].autorep ? "set" : "unset");
	notify(Playernum, buf);

     p->info[Playernum-1].autorep = !p->info[Playernum-1].autorep;
     putplanet(autoreport_pdata, p,
		Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
     close_file(autoreport_pdata);

     free(p);
 } else {
	  sprintf(buf,"Scope must be a planet or ship.\n");
	notify(Playernum, buf);
	  return(1);
   	}
 } else if (argn>2) {
 	sprintf(buf,"Autoreport: error in args.\n");
	notify(Playernum, buf);
	return(1);
   }

}
