/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h
 * build -- build a ship
 */

#include "GB_copyright.h"

#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "shipdata.h"
#include "buffers.h"
#include <curses.h>
#include <setjmp.h>
#include <signal.h>

int build_shdata,build_pdata,build_sectdata,sh_data_file, build_racedata;

make_mod(Playernum, APcount, argn, args, mode)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
int mode;
{
int i, value;
char shipc;
shiptype *dirship;
float getmass();

free(Race);
openracedata(&build_racedata);
getrace(build_racedata, &Race, Playernum);
close_file(build_racedata);


if(Dir[Playernum-1].level != LEVEL_SHIP) {
    notify(Playernum, "You have to change scope to a factory to program it.\n");
    return;
}

     openshdata(&build_shdata);
     if (!getship(build_shdata, &dirship, Dir[Playernum-1].shipno)) {
		sprintf(buf,"Illegal dir value.\n");
		notify(Playernum, buf);
		close_file(build_shdata);
		return;
	}
	close_file(build_shdata);
	if (testship(Playernum,dirship, Dir[Playernum-1].shipno))
		{
			free(dirship);
			return;
		}
if(dirship->type != OTYPE_FACTORY) {
    notify(Playernum, "That is not a factory.\n");
    free(dirship);
    return;
}

if(dirship->on && argn > 1) {
    notify(Playernum, "This factory is already online.\n");
    free(dirship);
    return;
}

if(mode==0) {
if(argn<2) {	/* list the current settings for the factory */
if(!dirship->build_type) {
	notify(Playernum, "No ship type specified.\n");
	free(dirship);
	return;
	}

notify(Playernum, "    - Current production specs -\n");
sprintf(buf, "  	   Ship type: %s\n", Shipnames[dirship->build_type]);
notify(Playernum, buf);
sprintf(buf, "	       class: %s\n", dirship->class);
notify(Playernum, buf);
sprintf(buf, "	       armor: %d\n", dirship->armor);
notify(Playernum, buf);
sprintf(buf, "	        guns: %d\n", dirship->guns);
notify(Playernum, buf);
sprintf(buf, "	        size: %d\n", dirship->size);
notify(Playernum, buf);
sprintf(buf, "	        crew: %d\n", dirship->max_crew);
notify(Playernum, buf);
sprintf(buf, "	    max fuel: %d\n", dirship->max_fuel);
notify(Playernum, buf);
sprintf(buf, " 	   max cargo: %d\n", dirship->max_resource);
notify(Playernum, buf);
sprintf(buf, "        max destruct: %d\n", dirship->max_destruct);
notify(Playernum, buf);
sprintf(buf, " 	   max speed: %d\n\n", dirship->max_speed);
notify(Playernum, buf);
sprintf(buf, "    Cost: %dr  Base Mass: %.1f\n", dirship->build_cost, dirship->base_mass);
notify(Playernum, buf);

    free(dirship);
    return;
}

shipc = args[1][0];

    i=0;
    while ((Shipltrs[i]!=shipc) && (i<NUMSTYPES)) i++;

if (i>=NUMSTYPES || (i==STYPE_POD && !Race->Thing) ) {
	sprintf(buf, "Illegal ship letter.\n");
	notify(Playernum, buf);
	return;
    } else if (Race->tech < Shipdata[i][ABIL_TECH] && !Race->God) {
	sprintf(buf,"You don't have enough technology to build one of those.\n");
	notify(Playernum, buf);
	return;
    } 

if(Shipdata[i][ABIL_BUILD] != Shipdata[OTYPE_FACTORY][ABIL_CONSTRUCT]) {
    notify(Playernum, "This kind of ship does not require a factory to construct.\n");
    free(dirship);
    return;
}

dirship->build_type = i;
dirship->armor = Shipdata[i][ABIL_ARMOR];
dirship->guns = Shipdata[i][ABIL_GUNS];
dirship->size = Shipdata[i][ABIL_TARGET];
dirship->max_crew = Shipdata[i][ABIL_MAXCREW];
dirship->max_resource = Shipdata[i][ABIL_CARGO];
dirship->max_fuel = Shipdata[i][ABIL_FUELCAP];
dirship->max_destruct = Shipdata[i][ABIL_DESTCAP];
dirship->max_speed = Shipdata[i][ABIL_SPEED];

sprintf(buf, "Factory designated to produce %ss.\n", Shipnames[i]);
notify(Playernum, buf);

} else if(mode==1) {

if(!dirship->build_type) {
	notify(Playernum, "No ship design specified. Use 'make <ship type>' first.\n");
	free(dirship);
	return;
}

if(argn<2) {
    notify(Playernum, "You have to specify the characteristic you wish to modify.\n");
    free(dirship);
    return;
} else if(argn<3) {
    notify(Playernum, "You have to specify the value you want the design set to.\n");
    free(dirship);
    return;
}
	   sscanf(args[2], "%d", &value);
if(value < 0) {
    notify(Playernum, "That's a ridiculous setting.\n");
    free(dirship);
    return;
}

if(!strncmp(args[1], "armor", strlen(args[1]))) {
    dirship->armor = MIN(value, 100);
} else if(!strncmp(args[1], "guns", strlen(args[1]))) {
    dirship->guns = MIN(value, 1000);
} else if(!strncmp(args[1], "size", strlen(args[1]))) {
    dirship->size = MAX(1, MIN(value, 1000));
} else if(!strncmp(args[1], "crew", strlen(args[1]))) {
    dirship->max_crew = MIN(value, 10000);
} else if(!strncmp(args[1], "cargo", strlen(args[1]))) {
    dirship->max_resource = MIN(value, 10000);
} else if(!strncmp(args[1], "fuel", strlen(args[1]))) {
    dirship->max_fuel = MIN(value, 10000);
} else if(!strncmp(args[1], "destruct", strlen(args[1]))) {
   dirship->max_destruct = MIN(value, 10000);
} else if(!strncmp(args[1], "speed", strlen(args[1]))) {
    dirship->max_speed = MAX(1,MIN(value, 9));
} else {
    notify(Playernum, "That characteristic either doesn't exist or can't be modified.\n");
    free(dirship);
    return;
}
    
} else {
    notify(Playernum, "Weird error.\n");
    free(dirship);
    return;
}
/* compute how much it's going to cost to build the ship */
dirship->build_cost = cost(dirship);
sprintf(buf, "The current cost of the ship is %d resources.\n",
	dirship->build_cost);
notify(Playernum, buf);
dirship->base_mass = getmass(dirship);
sprintf(buf, "The current base mass of the ship is %.1f.\n",
	dirship->base_mass);

		openshdata(&build_shdata);
		putship(build_shdata, dirship, Dir[Playernum-1].shipno);
		close_file(build_shdata);
free(dirship);

}


build(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int j,i,x= -1 ,y= -1 ,shipno, mask;
int load_fuel,load_crew,picked=0,cost,sh,found;
float fraction;
char c,shipc;
planettype *planet;
sectortype *sect;
shiptype s,*s2,*dirship;
FILE *fd;
char temp[128];
float getmass();

build_shdata = build_pdata = build_sectdata = NEUTRAL_FD;

free(Race);
openracedata(&build_racedata);
getrace(build_racedata, &Race, Playernum);
close_file(build_racedata);

 if (Dir[Playernum-1].level==LEVEL_PLAN) {
	if (!enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1], APcount)) {
		return;
 	} else {
     		openpdata(&build_pdata);
     		getplanet(build_pdata,&planet,
		Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
		close_file(build_pdata);
		shipc = args[1][0];
	    }
 } else if (Dir[Playernum-1].level==LEVEL_SHIP) {
     openshdata(&build_shdata);
     if (!getship(build_shdata, &dirship, Dir[Playernum-1].shipno)) {
		sprintf(buf,"Illegal dir value.\n");
		notify(Playernum, buf);
		close_file(build_shdata);
		return;
	}
	close_file(build_shdata);
	if (testship(Playernum,dirship, Dir[Playernum-1].shipno))
		{
			free(dirship);
			return;
		}

 	if (Shipdata[dirship->type][ABIL_CONSTRUCT]==0) {
		sprintf(buf,"This ship cannot be used to construct other ships.\n");
		notify(Playernum, buf);
		free(dirship);
		return;
	}

	if(dirship->type==OTYPE_FACTORY) {
		if(!dirship->on) {
			notify(Playernum, "This factory is not on line.\n");
			free(dirship);
			return;
			}

		if(dirship->damage) {
			notify(Playernum, "This factory cannot produce ships until the damage is zero.\n");
			free(dirship);
			return;
			}

		if(!dirship->popn) {
			notify(Playernum, "This factory doesn't have any crew!\n");
			free(dirship);
			return;
			}

		shipc = Shipltrs[dirship->build_type];
	} else
		shipc = args[1][0];

	if (dirship->is_docked && dirship->type != OTYPE_FACTORY) {
		if (dirship->whatdest==LEVEL_PLAN)
			{
			sprintf(buf,"This ship is landed.\n");
		notify(Playernum, buf);
			} else {
			sprintf(buf,"There is already a ship docked here (#%d).\n",
					dirship->destshipno);
		notify(Playernum, buf);
			}
		free(dirship);
		return;
	}

	 /* check stars, sdata for APs */
 	if (dirship->whatorbits==LEVEL_UNIV) {
	 	if (!enufAP(Playernum,Sdata.AP[Playernum-1], APcount))
			{
			free(dirship);
			return;
			}
 	} else if (dirship->whatorbits==LEVEL_STAR) {
	 	if (!enufAP(Playernum,Stars[dirship->storbits]->AP[Playernum-1], APcount))
			{
			free(dirship);
			return;
			}
	}

/* if we are at a factory, get the planet data too */
	if(dirship->type==OTYPE_FACTORY) {
     		openpdata(&build_pdata);
     		getplanet(build_pdata,&planet,
		Stars[dirship->deststar]->planetpos[dirship->destpnum]);
		close_file(build_pdata);
	}
 } else {
	sprintf(buf,"You can't build anything here.\n");
		notify(Playernum, buf);
	return;
 }



if(shipc=='?') {
     if (argn==2) {

       sprintf(buf, "ltr             ship  carg tg armr dstcap guns fcap tech ^crew speed cost\n");
	notify(Playernum, buf);
       for (i=0; i<NUMSTYPES; i++)
	  if (Race->tech >= Shipdata[i][ABIL_TECH] || Race->God)
	    if ((i==STYPE_POD && Race->Thing) || i!=STYPE_POD)
	      if(Shipdata[i][ABIL_PROGRAMMED]) {
	      sprintf(buf, " %c%18s%6d%3d%5d%7d%5d%5d%5d%5d%6d%6d\n",
		  Shipltrs[i], Shipnames[i],
		  Shipdata[i][ABIL_CARGO], Shipdata[i][ABIL_TARGET],
		  Shipdata[i][ABIL_ARMOR], Shipdata[i][ABIL_DESTCAP],
		  Shipdata[i][ABIL_GUNS], Shipdata[i][ABIL_FUELCAP], 
		  Shipdata[i][ABIL_TECH], Shipdata[i][ABIL_MAXCREW], 
		  Shipdata[i][ABIL_SPEED], Shipdata[i][ABIL_COST] );
	notify(Playernum, buf);
	}
     } else {
	/* description of an individual object, ala' examine */

	i = 0;
        while ((Shipltrs[i]!=args[2][0]) && (i<NUMSTYPES)) 
		i++;
        if (i<0 || i>=NUMSTYPES || (i==STYPE_POD && !Race->Thing)
	    || (Race->tech < Shipdata[i][ABIL_TECH] && !Race->God) ) {
		sprintf(buf, "You can't examine that ship type (yet).\n");
		notify(Playernum, buf);
	} else if(!Shipdata[i][ABIL_PROGRAMMED]) {
	  sprintf(buf, "This type of ship has not been programmed.\n");
	  notify(Playernum, buf);
	} else {
    	   if ((fd=fopen(EXAM_FL, "r"))==NULL) {
		perror(EXAM_FL);
		return;
    	   } else {
   	      /* look through ship data file */
	sprintf(buf, "\n");
    	      for (j=0; j<=i; j++)
       	         while (fgetc(fd) != '~') ;
		   /* give report */
    	      while ((c=fgetc(fd)) != '~') {
		sprintf(temp, "%c", c);
		strcat(buf, temp);
		}
	notify(Playernum, buf);
    	      fclose(fd) ;
	   }
	}
     }
return;
 }

    i=0;
    while ((Shipltrs[i]!=shipc) && (i<NUMSTYPES)) i++;


/* figure out if the ship can be constructed in the current scope */
if(Dir[Playernum-1].level==LEVEL_SHIP) {

if(dirship->type==OTYPE_FACTORY)
	i = dirship->build_type;

	if(Shipdata[i][ABIL_BUILD] != Shipdata[dirship->type][ABIL_CONSTRUCT]) {
	switch(Shipdata[dirship->type][ABIL_CONSTRUCT]) {
		case 0 :
			sprintf(buf, "%s cannot construct other ships.\n",
				Shipnames[dirship->type]);
			break;
		case 1 :
			sprintf(buf, "%s may only construct : or +.\n",
				Shipnames[dirship->type]);
			break;
		case 2 :
			sprintf(buf, "%s may only construct X, H, S, O, or m.\n",
				Shipnames[dirship->type]);
			break;
		case 3:
			sprintf(buf, "%s may only construct s, D, B, I, C, d, f, e, c, t, or =.\n",
				Shipnames[dirship->type]);
			break;
		}
		notify(Playernum, buf);
		free(dirship);
		return;
		}

} else if(Dir[Playernum-1].level == LEVEL_PLAN) {
	if(Shipdata[i][ABIL_BUILD] > 1) {
		switch(Shipdata[i][ABIL_BUILD]) {
		case 2 :
			sprintf(buf, "%s may only be constructed by s, c, S, H, or O.\n",
				Shipnames[i]);
			break;
		case 3 :
			sprintf(buf, "%s requires a factory to build it.\n",
				Shipnames[i]);
			break;
		default :
			sprintf(buf, "Weird error in build.\n");
			break;
		}
			notify(Playernum, buf);
			return;
	}
} else {
	notify(Playernum, "Illegal scope.\n");
	return;
	}

if (i>=NUMSTYPES || (i==STYPE_POD && !Race->Thing) ) {
	sprintf(buf, "Illegal ship letter.\n");
	notify(Playernum, buf);
	return;
    } else if (Race->tech < Shipdata[i][ABIL_TECH] && !Race->God) {
	sprintf(buf,"You don't have enough technology to build one of those.\n");
	notify(Playernum, buf);
	return;
    } 

	/* check for resource availability */

     if (Dir[Playernum-1].level==LEVEL_SHIP && 
		dirship->type != OTYPE_FACTORY &&
		dirship->resource < Shipdata[i][ABIL_COST]) {
	sprintf(buf,"Not enough resources on this ship (you need %d).\n", Shipdata[i][ABIL_COST]);
	notify(Playernum, buf);
	free(dirship);
	return;
     
     } else if(Dir[Playernum-1].level==LEVEL_SHIP &&
		dirship->type == OTYPE_FACTORY &&
		planet[Playernum-1].info->resource < dirship->build_cost) {
	sprintf(buf,"Not enough resources (%d) available.\n", dirship->build_cost);
	notify(Playernum, buf);
	free(dirship);
	return;
	}

	/* find sector to build on (if planet) */

     if (Dir[Playernum-1].level==LEVEL_PLAN || (Dir[Playernum-1].level==LEVEL_SHIP
			&& dirship->type==OTYPE_FACTORY)) {

if(Dir[Playernum-1].level==LEVEL_PLAN) {
	   sscanf(args[argn-1], "%d,%d", &x, &y);

if(x < 0 || x > planet->Maxx-1 || y < 0 || y > planet->Maxy-1) {
    notify(Playernum, "Illegal sector.\n");
    return;
}
} else {
/* get factory coordinates */
	x = (int)dirship->xpos;
	y = (int)dirship->ypos;
	}

	   opensectdata(&build_sectdata);
	   getsector(build_sectdata, &sect, planet->sectormappos+(y*planet->Maxx+x)*sizeof(sectortype));
	close_file(build_sectdata);


	 if (Dir[Playernum-1].level==LEVEL_PLAN &&
		planet->info[Playernum-1].resource < Shipdata[i][ABIL_COST]) {
		sprintf(buf, "not enough resources in stock (need %d).\n", 
				Shipdata[i][ABIL_COST]);
		notify(Playernum, buf);
		return;
	 } else if(Dir[Playernum-1].level==LEVEL_SHIP &&
			planet->info[Playernum-1].resource < dirship->build_cost) {
		sprintf(buf, "Not enough resources in stock (need %d).\n", 
				dirship->build_cost);
		notify(Playernum, buf);
		free(dirship);
		return;
		}

	   if (i == OTYPE_REPAIR) {
	       if(!sect->is_wasted) {
		   notify(Playernum, "You can only build on wasted sectors.\n");
		   return;
	       }

	       sect->is_wasted = 0;
		sect->fert = MIN(100, sect->fert+20);
		opensectdata(&build_sectdata);
	   	putsector(build_sectdata, sect, planet->sectormappos
				+(y*planet->Maxx+x)*sizeof(sectortype) );
		close_file(build_sectdata);

		planet->info[Playernum-1].resource -= 
		  Shipdata[OTYPE_REPAIR][ABIL_COST];
		sprintf(buf, "Sector %d,%d repaired.\n", x,y);
		notify(Playernum, buf);

		openpdata(&build_pdata);
		putplanet(build_pdata,planet,Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
		close_file(build_pdata);

		free(planet);
		return;
	} else if (sect->owner != Playernum) {
		sprintf(buf, "You don't own that sector.\n");
		notify(Playernum, buf);
		return;
	   }
	   load_crew = 0;
	   load_fuel = 0;
	 if(Race->autoload) {
	if(Dir[Playernum-1].level==LEVEL_PLAN) {
	   load_crew = MIN(Shipdata[i][ABIL_MAXCREW], sect->popn);
	   load_fuel = MIN(Shipdata[i][ABIL_FUELCAP], planet->info[Playernum-1].fuel);
	} else {
	   load_crew = MIN(dirship->max_crew, sect->popn);
	   load_fuel = MIN(dirship->max_fuel, planet->info[Playernum-1].fuel);
	}

	   sect->popn -= load_crew;
	   if (!sect->popn)
		sect->owner = 0;

	   planet->info[Playernum-1].fuel -= load_fuel;
	 }

    } else {
      load_crew = 0;
      load_fuel = 0;
      if(Race->autoload) {
	   load_crew = MIN(Shipdata[i][ABIL_MAXCREW], dirship->popn);
	   dirship->popn -= load_crew;
	   dirship->mass -= load_crew * Race->mass;
	   load_fuel = MIN(Shipdata[i][ABIL_FUELCAP], dirship->fuel);
	   dirship->fuel -= load_fuel;
	   dirship->fuel -= load_fuel * MASS_FUEL;
	 }
    }


 	Bzero(s);

	s.type = i;
	if (Dir[Playernum-1].level==LEVEL_PLAN) {
		s.xpos = (float)x;
		s.ypos = (float)y;
	} else {
		s.xpos = dirship->xpos + (float)(!(dirship->type==OTYPE_FACTORY));
		s.ypos = dirship->ypos;
	}

	if(Shipdata[i][ABIL_SPEED])
		s.speed = 1;
	else
		s.speed = 0;

	s.owner = Playernum;

	s.tech = Race->tech;
if(Dir[Playernum-1].level==LEVEL_SHIP && dirship->type==OTYPE_FACTORY) {
	s.armor = dirship->armor;
	s.guns = dirship->guns;
	s.size = dirship->size;
	s.max_crew = dirship->max_crew;
	s.max_resource = dirship->max_resource;
	s.max_destruct = dirship->max_destruct;
	s.max_fuel = dirship->max_fuel;
	s.max_speed = dirship->max_speed;
	s.build_cost = dirship->build_cost;
	s.build_type = dirship->build_type;
	s.base_mass = dirship->base_mass;
	sprintf(s.class, "%s", dirship->class);
			/* docked on the planet */
		s.whatorbits = LEVEL_PLAN;
		s.whatdest = LEVEL_PLAN;
		s.deststar = dirship->deststar;
		s.destpnum = dirship->destpnum;
		s.storbits = dirship->storbits;
		s.pnumorbits = dirship->pnumorbits;
	} else {
	s.armor = Shipdata[i][ABIL_ARMOR];
	s.guns = Shipdata[i][ABIL_GUNS];
	s.size = Shipdata[i][ABIL_TARGET];
	s.max_crew = Shipdata[i][ABIL_MAXCREW];
	s.max_resource = Shipdata[i][ABIL_CARGO];
	s.max_fuel = Shipdata[i][ABIL_FUELCAP];
	s.max_speed = Shipdata[i][ABIL_SPEED];

	if(i!=OTYPE_FACTORY)
		s.build_type = i;
	else
		s.build_type = 0;

	s.build_cost = Shipdata[i][ABIL_COST];
	s.base_mass = getmass(&s);
	sprintf(s.class, "Standard");

	if (Dir[Playernum-1].level==LEVEL_SHIP) {
		s.whatdest = LEVEL_SHIP;
		s.destshipno = Dir[Playernum-1].shipno;
		s.whatorbits = dirship->whatorbits;
	} else {
			/* docked on the planet */
		s.whatorbits = LEVEL_PLAN;
		s.whatdest = LEVEL_PLAN;
		s.deststar = Dir[Playernum-1].snum;
		s.destpnum = Dir[Playernum-1].pnum;
	}
	s.storbits = Dir[Playernum-1].snum;
	s.pnumorbits = Dir[Playernum-1].pnum;
}

	s.fuel = load_fuel;
	s.popn = load_crew;
	s.destruct = s.resource = 0;

	s.mass = s.base_mass + load_crew*Race->mass + load_fuel*MASS_FUEL;
	s.is_alive = 1;
 	s.active = 1;

	if(s.guns)
	 	s.protect.self = 1;
	else
		s.protect.self = 0;

	s.hyper_drive.on = 0;
	s.hyper_drive.ready = 0;
	s.hyper_drive.charge = 0;

	s.is_docked = 1;

	s.rad = 0;
	s.damage = Shipdata[s.type][ABIL_DAMAGE];

	s.object.number = 0;
	s.object.number2 = 0;
	s.object.number3 = 0;
	s.object.number4 = 0;

	if (has_switch(&s))
		s.on = 0;

	switch (s.type) {

	    case OTYPE_VN:
		s.object.number = 1;	/* one of them */
		s.object.number2 = 1;	/* we have an assignment */
		s.on = 1;
		break;
	    case STYPE_MINE:
		s.object.number = 100;	/* trigger radius */
		sprintf(buf, "Mine disarmed.\nTrigger radius set to 100.\n");
		notify(Playernum, buf);
		break;
	    case OTYPE_TRANSDEV:
		sprintf(buf, "Receive OFF.  Change with order.\n");
		notify(Playernum, buf);
		break;
	    case OTYPE_AP:
		sprintf(buf, "Processor OFF.\n");
		notify(Playernum, buf);
		break;
	    case OTYPE_TOXWC:
		sprintf(buf, "Toxin concentration of the planet was %d,",
				planet->conditions[TOXIC]);
		notify(Playernum, buf);
		if (planet->conditions[TOXIC] > TOXMAX) {
			planet->conditions[TOXIC] -= TOXMAX;
			s.object.number = TOXMAX;
		} else {
			s.object.number = planet->conditions[TOXIC];
			planet->conditions[TOXIC] = 0;
		}
		sprintf(buf, " now %d.\n",planet->conditions[TOXIC]);
		notify(Playernum, buf);
		break;
	    case OTYPE_STELE:
	    case OTYPE_GTELE:
		sprintf(buf, "Telescope range is %.2f.\n", tele_range(s.type,s.tech));
		notify(Playernum, buf);
		break;
	    default:
		break;
	}


		/* deduct resource cost */

	if (Dir[Playernum-1].level==LEVEL_PLAN || (Dir[Playernum-1].level==LEVEL_SHIP &&
			dirship->type==OTYPE_FACTORY))
		planet->info[Playernum-1].resource -= s.build_cost;
	else
		dirship->resource -= s.build_cost;

	sprintf(buf, "Ship built at a cost of %d resources.\n", s.build_cost);
	notify(Playernum, buf);

		/* check for dead ships in the data files */

	 /* erase any '0' entries in the dead ship file, which shouldn't be there */
	while ( (shipno = getdeadship()) == 0){ };

	if ( shipno == -1) {
			/* otherwise recycle topmost dead ship in data file. */
			/* no dead ships to recycle */
	    openshdata(&build_shdata);
	    shipno = Numships(build_shdata) + 1;
	    close_file(build_shdata);
	}

	sprintf(buf, "%s #%d is %s %.0f,%.0f.\n", Shipnames[s.type], shipno,
		(Dir[Playernum-1].level==LEVEL_SHIP && dirship->type != OTYPE_FACTORY)
				 ? "at" : "on sector", s.xpos,s.ypos);
		notify(Playernum, buf);

		/* insert ship into planet's orbit */
	if (Dir[Playernum-1].level==LEVEL_PLAN || (Dir[Playernum-1].level==LEVEL_SHIP
		&& dirship->type==OTYPE_FACTORY)) {
		 /* built on planet */
		 /* next ship on list */
		s.nextship = planet->ships;
		planet->ships = shipno;
		openpdata(&build_pdata);
		putplanet(build_pdata,planet,
			Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
		close_file(build_pdata);
	        free(planet);

		  /* write sector to disk */
	opensectdata(&build_sectdata);
	   	putsector(build_sectdata, sect, planet->sectormappos+(y*planet->Maxx+x)*sizeof(sectortype) );
	close_file(build_sectdata);

	   	free(sect);

	} else {	/* was built on a ship -- insert after that ship */

		s.nextship = dirship->nextship;
		dirship->nextship = shipno;

		dirship->is_docked = 1;
		dirship->whatdest = LEVEL_SHIP;
		dirship->destshipno = shipno;

		openshdata(&build_shdata);
		putship(build_shdata, dirship, Dir[Playernum-1].shipno);
		close_file(build_shdata);

	    }
if(Shipdata[s.type][ABIL_DAMAGE]) {
  sprintf(buf, "Warning: This ship is constructed with a %d%% damage level.\n",
	    Shipdata[s.type][ABIL_DAMAGE]);
    notify(Playernum, buf);

if(s.max_resource)
    notify(Playernum, "It will need resources to make fully operational.\n");
else
    notify(Playernum, "This ship does not need resources to repair.\n");
}


openshdata(&build_shdata);
putship(build_shdata,&s,shipno);
close_file(build_shdata);

    if (Dir[Playernum-1].level==LEVEL_SHIP && dirship->whatorbits==LEVEL_UNIV)
	    deductAPs(Playernum, APcount, 0, 1);
    else 
	    deductAPs(Playernum, APcount, Dir[Playernum-1].snum, 0);

if(Dir[Playernum-1].level==LEVEL_SHIP) free(dirship);

if(Race->autoload) {
    sprintf(buf, "Loaded with %d crew and %d fuel.\n", load_crew,load_fuel);
     notify(Playernum, buf);
	}
}

float getmass(s)
shiptype *s;
{
float base_mass;
base_mass = MAX(1.0, (float)s->armor + (float)s->size/10.0 + (float)s->guns/10.0);
return(base_mass);
}

int cost(s)
shiptype *s;
{
int i;
float advantage, disadvantage, factor;

advantage = 0.;
disadvantage = 0.;

i=s->build_type;
/* compute how much it costs to build this ship */
/* armor */
factor = (((float)s->armor + 1.0)/((float)Shipdata[i][ABIL_ARMOR]+1.0)) - 1.0;
if(factor >= 0.0)
	advantage += factor;
else
	disadvantage -= factor;

/* guns */
factor = (((float)s->guns + 1.0)/((float)Shipdata[i][ABIL_GUNS]+1.0)) - 1.0;
if(factor >= 0.0)
	advantage += factor;
else
	disadvantage -= factor;

/* size */
factor = (((float)s->size + 1.0)/((float)Shipdata[i][ABIL_TARGET]+1.0)) - 1.0;
if(factor >= 0.0)
	advantage += factor;
else
	disadvantage -= factor;

/* crew */
factor = (((float)s->max_crew + 1.0)/((float)Shipdata[i][ABIL_MAXCREW]+1.0)) - 1.0;
if(factor >= 0.0)
	advantage += factor;
else
	disadvantage -= factor;

/* cargo capacity */
factor = (((float)s->max_resource + 1.0)/((float)Shipdata[i][ABIL_CARGO]+1.0)) - 1.0;
if(factor >= 0.0)
	advantage += factor;
else
	disadvantage -= factor;

/* fuel capacity */
factor = (((float)s->max_fuel + 1.0)/((float)Shipdata[i][ABIL_FUELCAP]+1.0)) - 1.0;
if(factor >= 0.0)
	advantage += factor;
else
	disadvantage -= factor;

/* destruct capacity */
factor = (((float)s->max_destruct + 1.0)/((float)Shipdata[i][ABIL_DESTCAP]+1.0)) - 1.0;
if(factor >= 0.0)
	advantage += factor;
else
	disadvantage -= factor;

factor = (((float)s->max_speed + 1.0)/((float)Shipdata[i][ABIL_SPEED]+1.0)) - 1.0;
if(factor >= 0.0)
	advantage += factor;
else
	disadvantage -= factor;

factor = (1.+advantage)/(1.+disadvantage);

return ((int)(factor * (float)Shipdata[i][ABIL_COST]));

}



