/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 * daemon.c -- sleep for awhile, then do a turn
 */

#include "GB_copyright.h"
#include "config.h"
#include "tweakables.h"
#include "files.h"
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <sys/file.h>
#include <sys/ioctl.h>

main(argc,argv)
int argc;
char *argv[];
{
 struct tm *t;
 long clk;
 int updtime,exstat,turn=0,update=0,fd2;
 FILE *fd;
char buf[128];

 if (fork()) exit();		/* detach from shell */

 sigblock(SIGHUP|SIGQUIT);  /* ignore signal from owner logging out */


  fd2 = open("/dev/tty", O_RDWR);	/* disassociate from tty */
  ioctl(fd2, TIOCNOTTY, 0);
  close(fd2);

  if (argc>1)
	updtime = atoi(argv[1]);
  else
	updtime = DEFAULT_UPDATE_TIME;

  /* initialize the data file to feed telnet */
  if ((fd = fopen(DAEMONFL, "w")) == NULL)
	perror("GB_daemon open of daemon.dat failed");
  else
	fprintf(fd, "%s\n%s\n", DAEMON_PASSWORD, QUIT_COMMAND);
  fclose(fd);

 while (1) {

   clk = time(0);
   t = localtime(&clk);

   printf("day %d,hour %d,min %d,sec %d\n",
		t->tm_mday, t->tm_hour, t->tm_min, t->tm_sec);

   if ( (t->tm_hour % updtime)==0 && update!=t->tm_hour ) {
   	update = t->tm_hour;
	printf("Requesting update\n");
	/* this will trigger the update */
	/*
	exstat = system("telnet pooh 2010 < daemon.dat");
	 */
	sprintf(buf,"telnet %s %d < %s", GB_HOST, GB_PORT, DAEMONFL);
	exstat = system(buf);

	fd = fopen(PROFDATAFL, "a");
	   clk = time(0);
	   t = localtime(&clk);
	fprintf(fd,"turn %d @ day %d,hour %d,min %d,sec %d, time=%d secs, exit %d\n",
		turn++, t->tm_mday, t->tm_hour, t->tm_min, t->tm_sec, 
		t->tm_min * 60 + t->tm_sec, exstat);
	fclose(fd);
   } else 
	sleep(600);
 }

}
