int Sectormappos;
/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *  doplanet.c -- do one turn on a planet.
 */ 

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "doturn.h"
#include "power.h"
#include "buffers.h"
#include <math.h>

extern float compatibility();

	/* types of accidents that can occur on a toxic planet. */
char *Accidents_uninhab[] = {
	 /* on water sectors */
	"Widespread waste spill",
	"Ecological instability",
	 /* on land sectors */
	"Massive volcanic eruptions",
	"Ecological instability",
	 /* on mountain sectors */
	"Massive volcanic eruptions",
	"Ecological instability",
	 /* gas sectors */
	"Lethal toxin concentration",
	"Ecological instability",
	 /* ice */
	"Leak in isolated chemical plant",
	"Continental warming cause glacial melting",
	 /* plate */
	"Nuclear accident",
	"Untended nuclear plant explodes"
};

char *Accidents_inhab[] = {
	"Nuclear accident",
	"Terrorists trigger nuclear weapon",
	"Release of toxic waste",
	"Weapons dump explosion",
	"Massive starvation",
	"Virus epidemic",
	"famine",
	"starvation",
	"Widespread cultist suicide",
	"Atomic experiment gone wrong",
	"Great Hrung collapse"
};


int doplanet(starnum,planet, planetnum)
int starnum;
planettype *planet;
int planetnum;
{
int shipno,x,y,nukex,nukey;
int o=0,j;
char *nukem;
reg int i;
sectortype *p;
shiptype *ship;
float madd,fadd;
int sectdata,timer=20;
int oldplanetpopn, oldplanetmaxpopn;
boolean allmod=0,allexp=0;
char buf[200]; 

Sectormappos = planet->sectormappos;
check(planet,0);
if (!StarsInhab[starnum])
	return 0;	/* no one's here now */

if (Stinfo[starnum][planetnum].inhab) {
/*	printf(" getting sectmap pos %d\n",planet->sectormappos); */
	opensectdata(&sectdata);
	getsmap(sectdata,Smap,planet);
	close_file(sectdata);

	PermuteSects(planet);
	bzero((char *)Sectinfo, sizeof(Sectinfo) );
}



check(planet,1);
  shipno = planet->ships;

  while (shipno) {

	if ( ((ship = ships[shipno])!=NULL) && ship->is_alive && !ship->rad) {

	   if ( !(ship->is_docked && ship->whatdest==LEVEL_PLAN)) {
		 /* add fuel to ships orbiting gas giants */
		if (planet->type == TYPE_GASGIANT) {
		 if (ship->type == STYPE_TANKER) {
		    fadd = FUEL_GAS_ADD_TANKER;
		    madd = FUEL_GAS_ADD_TANKER*MASS_FUEL;
		 } else if (ship->type == STYPE_HABITAT) {
		    fadd = FUEL_GAS_ADD_HABITAT;
		    madd = FUEL_GAS_ADD_HABITAT*MASS_FUEL;
		 } else {
		    fadd = FUEL_GAS_ADD;
		    madd = FUEL_GAS_ADD*MASS_FUEL;
		 }
		 if (ship->fuel + fadd > Max_fuel(ship)) {
		    madd -= (Max_fuel(ship) - (ship->fuel+fadd))*MASS_FUEL;
		    fadd = Max_fuel(ship)-(ship->fuel+fadd);
		 }
		 ship->fuel += fadd;
		 ship->mass += madd;
		}
	   }

	    if (ship->type == OTYPE_VN || (ship->type==OTYPE_BERS && !ship->destruct)) {		 
										/* Von Neumann machine/unarmed Berserker */
	     	planet_doVN(ship,shipno,planet);
	    } else if (ship->type == OTYPE_TERRA) {	 /* terraforming device. */

		 if (ship->fuel >= (float)FUEL_COST_TERRA) { 

		if (ship->on && 
		    ((ship->whatdest == LEVEL_PLAN) && ship->is_docked)) {

		   /* move, and then terraform. */

		 if (ship->xpos >= (planet->Maxx-1) && ship->object.number > 0)
		   ship->xpos = 0.0;
		 else if (ship->xpos <= 0.0 && ship->object.number < 0)
		   ship->xpos = (planet->Maxx-1);
		 else
		   ship->xpos += ship->object.number;

		 if (ship->ypos <= 0.0 && ship->object.number2 < 0)
			ship->object.number2 = -ship->object.number2;
		 else if (ship->ypos >= (planet->Maxy-1) && ship->object.number2 > 0)
			ship->object.number2 = -ship->object.number2;
		 
		ship->ypos += ship->object.number2;

		   {
		    sectortype *s;
		    s = &Sector(*planet,(int)ship->xpos,(int)ship->ypos);
		    if (s->des != DES_GAS && 
			(int_rand(1,100) <= (((100-ship->damage) * 
				  ship->popn)/Max_crew(ship)))) {
			  /* gas sectors can't be terraformed. */
		 	s->des = races[ship->owner-1]->likesbest;
		 	s->eff *= 0.5;
		 	s->mobilization *= 0.5;
		 	s->resource *= 0.7;
		 	/*s->popn *= 0.5;*/	/* ?? not sure bout this */
			s->popn = 0;
			s->owner = 0;/* i AM sure about this :) */
		 	ship->fuel -= (float)FUEL_COST_TERRA;
		 	ship->mass -= FUEL_COST_TERRA*MASS_FUEL;
			if (planet->conditions[TOXIC]<100)
				planet->conditions[TOXIC] += random()&01;
		      }
		 } 

	       }
	      } else if (!ship->notified) {  
		char teleg2_buf[1000];
	        ship->notified = 1;
		msg_OOF(ship, shipno, teleg2_buf);
	      }

	 } else if (ship->type==OTYPE_BERS && ship->destruct) {
	    if (ship->bombard && ship->whatorbits==LEVEL_PLAN &&
	     ship->whatdest==LEVEL_PLAN &&
	     ship->storbits==ship->deststar &&
	     ship->pnumorbits==ship->destpnum &&
	     !ship->is_docked)
		if (!Bombard(ship, shipno, planets[ship->storbits][ship->pnumorbits],
				races[ship->owner-1])) {
			/* we killed everyone here; go somewhere else */
		   ship->destpnum = int_rand(0,Stars[ship->storbits]->numplanets);
		} else {
			/* exact revenge */
		   if (Sdata.VN_hitlist[ship->object.number-1]>0)
			   Sdata.VN_hitlist[ship->object.number-1]--;
		}
	 } else if (can_bombard(ship) && ship->bombard &&
	     ship->whatorbits==LEVEL_PLAN &&
	     ship->whatdest==LEVEL_PLAN &&
	     ship->storbits==ship->deststar &&
	     ship->pnumorbits==ship->destpnum &&
	     !ship->is_docked)
		Bombard(ship, shipno, planets[ship->storbits][ship->pnumorbits], races[ship->owner-1]);


	}
  	shipno = ship->nextship;
check(planet,2);
  }


 if (!Stinfo[starnum][planetnum].inhab && 
     !Stinfo[starnum][planetnum].Thing_add)
	return 0;	/* (no one's explored the planet) */


	/* check for space mirrors (among other things) warming the planet */
	/* if a change in any artificial warming/cooling trends */
 if (Stinfo[starnum][planetnum].temp_add != 0) {
	int final_temp;

	final_temp = planet->conditions[RTEMP] +
			 Stinfo[starnum][planetnum].temp_add + int_rand(-5,5);

	planet->conditions[TEMP] = final_temp;
 }
 else planet->conditions[TEMP] = planet->conditions[RTEMP] + int_rand(-5,5);

 if (planet->slaved_to)
	planet->is_sheep = 1;	/* this is set to 0 at the end of ea. turn */

 check(planet,3);

 if (Stinfo[starnum][planetnum].Thing_add>0) {
	 /* start a meso colony */
	int p;
/*	printf(" getting sectmap pos %d\n",planet->sectormappos); */
	opensectdata(&sectdata);
	getsmap(sectdata,Smap,planet);
	close_file(sectdata);

	PermuteSects(planet);
	bzero((char *)Sectinfo, sizeof(Sectinfo) );
	x = int_rand(0,planet->Maxx-1);
	y = int_rand(0,planet->Maxy-1);
	p = Stinfo[starnum][planetnum].Thing_add;
/*	printf("spore landed st %d, plan %d, play %d.\n", starnum,planetnum,p);*/
	planet->info[p-1].numsectsowned = 1;

	planet->info[p-1].explored = 1;
	Sector(*planet,x,y).popn = 1;
	Sector(*planet,x,y).owner = p;
	Sector(*planet,x,y).is_wasted = 0;
}

bzero((char *)avg_mob, sizeof(avg_mob) );
bzero((char *)sects_gained, sizeof(sects_gained) );
bzero((char *)sects_lost, sizeof(sects_lost) );
bzero((char *)populations, sizeof(populations) );
bzero((char *)prod_res, sizeof(prod_res) );
bzero((char *)prod_fuel, sizeof(prod_fuel) );
bzero((char *)prod_destruct, sizeof(prod_destruct) );

tot_resdep = prod_eff= prod_mob = tot_captured = 0;
Claims = 0;

oldplanetmaxpopn = planet->maxpopn;
planet->maxpopn = 0; 

oldplanetpopn = planet->popn;
planet->popn = 0;	/* initialize population for recount */ 

/* reset global variables */
for (i=1; i<=Num_races; i++) {
	Compat[i-1] = compatibility(planet, races[i-1]);
	planet->info[i-1].numsectsowned = 0;
	populations[i-1] = 0;
	prod_fuel[i-1] = 0;
	prod_destruct[i-1] = 0;
	prod_res[i-1] = 0;
	avg_mob[i-1] = 0.0;
}

Getxysect(planet, &x, &y, 1);
/*printf(" while %d\n",Getxysect(planet, &x, &y, 1));	/* reset */

check(planet,4);
while (Getxysect(planet, &x, &y, 0)) {
       p = &Sector(*planet,x,y);
	 if (p->owner) {
		/* (all modified; sectors belonging to that player modified) */
	    allmod = 1;	
	    if (p->popn == 0) {
		  p->owner=0;	/* make wasted/unowned sects go to player 0 */
	    } else {
	      if (!Stars[starnum]->nova_stage) {
	       		/* spread excess popn to surrounding sects */
	      		produce(planet,p);	/* >produce stuff there */
	      		spread(planet,p,x,y);	
	      } else {
			/* damage sector from supernova */
			p->resource++;
			p->fert *= 0.95;
			if (Stars[starnum]->nova_stage == 14)
				p->popn = p->owner = 0;
			else
				p->popn = round_rand((float)p->popn * .50);
	      }

	    }

	      Sectinfo[x][y].done = 1;

	  }


       	if (p->owner) {
	      planet->info[p->owner-1].numsectsowned++;
	      planet->popn += p->popn;
	      Power[p->owner-1].popn += p->popn;
	      Power[p->owner-1].sum_eff += p->eff;
               Power[p->owner-1].sum_mob += p->mobilization;
	      starpopns[starnum][p->owner-1] += populations[p->owner-1] += p->popn;
	      planet->maxpopn += maxsupport(races[p->owner-1],p,
				  Compat[p->owner-1],planet->conditions[TOXIC]);
	}



         if (p->is_wasted) {
	 	if (x>1 && x<planet->Maxx-2) {
			if (p->des==DES_SEA || p->des==DES_GAS) {
				/* don't reclaim pole sectors */
		  		if ( y>1 && y<planet->Maxy-2 && 
					(!(p-1)->is_wasted || !(p+1)->is_wasted)
					&& !random()%5)
					p->is_wasted = 0;
	      		} else if (p->des==DES_LAND || p->des==DES_MOUNT || p->des==DES_ICE) {
				if ( y>1 && y<planet->Maxy-2 && 
				   ((p-1)->popn || (p+1)->popn)
				   && !random()%10)
					p->is_wasted = 0;
      			}
		}
         }

	 /* evaporate the oceans on novae */
     if (Stars[starnum]->nova_stage) {
       if (p->des==DES_ICE)
	   p->des = DES_LAND;
       else if (p->des==DES_SEA)

	  if ( (x>0 && (p-1)->des==DES_LAND) ||
	     (x<planet->Maxx-1 && (p+1)->des==DES_LAND) || 
	     (y>0 && (p-planet->Maxx)->des==DES_LAND) ||
	     (y<planet->Maxy-1 && (p+planet->Maxx)->des==DES_LAND ) ) {
	       p->des = DES_LAND;
	       p->popn = p->owner = 0;
	       p->resource += 3;
	       p->fert = int_rand(1,4);
/*	       printf("sect %d,%d evaporated.\n",x,y); */
	}
     }

}
check(planet,5);

if (allmod) {	/* ( >= 1 inhabited sector on the planet) */

check(planet,51);
	 if (planet->expltimer >= 1)
		planet->expltimer--;
	 if (!Stars[starnum]->nova_stage && !planet->expltimer) {
	  if (!planet->expltimer)
		planet->expltimer = 5;
	   for (i=1; !Claims && !allexp && i<=Num_races; i++) {
check(planet,6);
		 /* sectors have been modified for this player*/

	     if (planet->info[i-1].numsectsowned)
	      while (!Claims && !allexp && timer>0) {
		timer -= 1;
		o = 1;
		Getxysect(planet, &x, &y, 1);
		while (!Claims && Getxysect(planet, &x, &y, 0)) {
			  /* find out if all sectors have been explored */
			o &= Sectinfo[x][y].explored;
			p = &Sector(*planet,x,y);
			if (( (Sectinfo[x][y].explored==i) && !(random()&02) ) 
			    && (!p->owner && !p->is_wasted && p->des==races[i-1]->likesbest) ) {
				 /*  explorations have found an island */
/*				printf("found island @ %d,%d\n",x,y);*/
				Claims = i;
				 /* give them some free people there */
				p->popn = races[i-1]->number_sexes;
				p->owner = i;
				tot_captured = 1;
			} else {

				explore(planet, p, x, y, i);
				check(planet,63);
				}
		}
		allexp |= o;	/* all sectors explored for this player */

	       }
           }
	 }
	if (allexp)
		planet->expltimer = 5;

check(planet,7);
		/* environment nukes a random sector */
   if (planet->conditions[TOXIC] > ENVIR_DAMAGE_TOX) {
	nukex = int_rand(0,planet->Maxx-1);
	nukey = int_rand(0,planet->Maxy-1);
	p = &Sector(*planet,nukex,nukey);
	if (p->owner)
		planet->info[p->owner-1].numsectsowned--;
	p->is_wasted = 1;
		/* index into accident type array */
	nukem = p->popn ? 
			/* random disaster */
		Accidents_inhab[int_rand(0,sizeof(Accidents_inhab)/sizeof(char *))]
				/* random of two disasters for that sec type*/
		: Accidents_uninhab[p->des * 2 + (random()&01)];
	p->popn = p->owner = 0;
   }

	for (i=1; i<=Num_races; i++)
	  if (sects_gained[i-1] || sects_lost[i-1]) {
	  sprintf(telegram_buf,"****** Report: Planet /%s/%s ******\n", 
		Stars[starnum]->name, Stars[starnum]->pnames[planetnum] );
		  sprintf(buf," \nWAR STATUS: %d sectors gained, %d sectors lost.\n", sects_gained[i-1],sects_lost[i-1]);
	str_cat(telegram_buf, buf);
	push_message(TELEG_PLAYER_AUTO, i, telegram_buf);
	  }

	for (i=1; i<=Num_races; i++)
	 if (planet->info[i-1].autorep) {

check(planet,8);
/*	  planet->info[i-1].autorep = planet->info[i-1].autorep - 1; */
check(planet,85);
	  sprintf(telegram_buf,"\nFrom /%s/%s\n", 
		Stars[starnum]->name, Stars[starnum]->pnames[planetnum] );
	  if (Stinfo[starnum][planetnum].temp_add) {
		sprintf(buf,"Temp: %d to %d\n", 
			Temp(planet->conditions[RTEMP]), Temp(planet->conditions[TEMP]));
		str_cat(telegram_buf, buf);
	  }
	  sprintf(buf, "Total      Prod: %dr %df %dd\n", prod_res[i-1], prod_fuel[i-1],
			prod_destruct[i-1]);
	str_cat(telegram_buf, buf);

	if(tot_captured) {
	  sprintf(buf,"%d sectors captured\n", tot_captured);
	str_cat(telegram_buf, buf);
		}

	  if (Stars[starnum]->nova_stage) {
		sprintf(buf,"This planet's primary is in a Stage %d nova.\n", 
			Stars[starnum]->nova_stage);
		str_cat(telegram_buf, buf);
	  }

		/* remind the player that he should clean up the environment. */
	  if (planet->conditions[TOXIC] > ENVIR_DAMAGE_TOX) {
		sprintf(buf,"Environmental damage on sector %d,%d\n", nukex, nukey);
		str_cat(telegram_buf, buf);
	  }

	  if (planet->slaved_to) {
		sprintf(buf, "ENSLAVED to player %d\n", planet->slaved_to);
		str_cat(telegram_buf, buf);
	  }

 push_message(TELEG_PLAYER_AUTO, i, telegram_buf);

	}
check(planet,9);

	   /* find out who is on this planet, for nova notification */
	if (Stars[starnum]->nova_stage == 1) {
	     sprintf(telegram_buf,"BULLETIN from /%s/%s\n", Stars[starnum]->name, Stars[starnum]->pnames[planetnum]);
	     sprintf(buf,"\nStar %s is undergoing nova.\n", Stars[starnum]->name);
	str_cat(telegram_buf, buf);
	     if (planet->type==TYPE_EARTH) {
		sprintf(buf,"Seas and rivers are boiling!\n",telegram_buf,0);
		str_cat(telegram_buf, buf);
		}
	     sprintf(buf, "This planet must be evacuated immediately!\n%c", TELEG_DELIM);
		str_cat(telegram_buf, buf);
     	     for (i=1; i<=Num_races; i++)
		if (planet->info[i-1].numsectsowned) {
		push_message(TELEG_PLAYER_AUTO, i, telegram_buf);
		}
 	}


check(planet,10);
   for (i=1; i<=Num_races; i++) {

/* check to see if your guys steal all alien resources on the planet,
	this requires that you be the only one inhabiting the planet */

	if (planet->info[i-1].numsectsowned > 0) {
		int aliensects=0,stolenres=0,stolendes=0,stolenfuel=0;
		int stuff=0;


		for (j=2; j<=Num_races; j++)  
			if(j!=i)
			{
			aliensects += planet->info[j-1].numsectsowned;
			if(planet->info[j-1].resource >0 ||
			   planet->info[j-1].destruct >0 ||
			   planet->info[j-1].fuel > 0.0) stuff=1;
			}

		if(!aliensects && stuff)
			{
		for (j=1; j<=Num_races; j++)
			if(j!=i)
			{
			  stolenres += planet->info[j-1].resource;
			  stolendes += planet->info[j-1].destruct;
			  stolenfuel += planet->info[j-1].fuel;
			  planet->info[j-1].resource = 0;
			  planet->info[j-1].destruct = 0;
			  planet->info[j-1].fuel = 0;
			}
		planet->info[i-1].resource += stolenres;
		planet->info[i-1].destruct += stolendes;
		planet->info[i-1].fuel += stolenfuel;
/* notify player of recovered stockpiles */
	  sprintf(telegram_buf,"****** Report: Planet /%s/%s ******\n\n", 
		Stars[starnum]->name, Stars[starnum]->pnames[planetnum] );
	  sprintf(buf," %d resources \n %d destruct \n %d fuel recovered from alien stock piles",stolenres,stolendes,stolenfuel);
	str_cat(telegram_buf, buf);
	push_message(TELEG_PLAYER_AUTO, i, telegram_buf);
			} /*aliensect==0*/
		}

	if (planet->info[i-1].numsectsowned) {
	  /* combat readiness naturally moves towards the avg mobilization */
		avg_mob[i-1] /= planet->info[i-1].numsectsowned;
		planet->info[i-1].comread += 
			    sgn(avg_mob[i-1] - planet->info[i-1].comread);
 	}
   }

	if (planet->maxpopn > 0 && planet->conditions[TOXIC]<100)
 	   planet->conditions[TOXIC] += 
/* 		     round_rand(MIN((float)(planet->popn / 
				    (float)planet->maxpopn),2.0)); */
				    planet->popn/planet->maxpopn;
                     /* Rob, this is a better idea, or toxic go wild
			    other effects can make this happen
			    keeps waste containers down too -
			    playtesting has proved this to us at OSU */

	if (planet->conditions[TOXIC] > 100)
	   planet->conditions[TOXIC] = 100;
	else if (planet->conditions[TOXIC] < 0)
	   planet->conditions[TOXIC] = 0;

	/* deal with enslaved planets */
   if (planet->slaved_to) {
	if (populations[planet->slaved_to-1] >= planet->popn * 0.001 ||
		(Stinfo[starnum][planetnum].intimidated && random()&01) ) {
/*		 printf("enslaved!\n"); */
		for (i=1; i<=Num_races; i++)
		    /* add production to slave holder of planet */
		  if (planet->info[i-1].numsectsowned) {
			planet->info[planet->slaved_to-1].resource += 
					prod_res[i-1];
			prod_res[i-1] = 0;
			planet->info[planet->slaved_to-1].fuel += 
					prod_fuel[i-1];
			prod_fuel[i-1] = 0;
			planet->info[planet->slaved_to-1].destruct += 
					prod_destruct[i-1];
			prod_destruct[i-1] = 0;
		  }
	} else {
		 /* slave revolt! */
/*	printf("slave revolt!\n"); */
		 /* first nuke some random sectors from the revolt */
		i = planet->popn / 1000 + 1;
/*	printf("i %d  Maxx %d  Maxy %d\n",i,planet->Maxx,planet->Maxy); */
		while (--i) {
			p = &Sector(*planet,int_rand(0,planet->Maxx-1),
					int_rand(0,planet->Maxy-1));
			if (p->popn) {
				p->owner = p->popn = 0;
				p->is_wasted = 1;
			}
		}
		 /* now nuke all sectors belonging to former master */
		Getxysect(planet, &x, &y, 1);
		while (Getxysect(planet, &x, &y, 0)) {
			if (Stinfo[starnum][planetnum].intimidated && random()&01) {
			   p =  &Sector(*planet,x,y);
			   if (p->owner==planet->slaved_to) {
				p->owner = 0;
				p->popn = 0;
				p->is_wasted = 1;
			   }
			}
		}
		sprintf(telegram_buf,"NOTICE from planet /%s/%s!\n",
				Stars[starnum]->name,
				Stars[starnum]->pnames[planetnum]);
		sprintf(buf,"\nThere has been a SLAVE REVOLT on this planet!\n");
			str_cat(telegram_buf, buf);
		sprintf(buf,"All population belonging to player #%d on the planet have been killed!\n",planet->slaved_to);
			str_cat(telegram_buf, buf);
		sprintf(buf,"Productions now go to their rightful owners.\n");
			str_cat(telegram_buf, buf);
		for (i=1; i<=Num_races; i++)
		  if (planet->info[i-1].numsectsowned && i!=planet->slaved_to) {
			push_message(TELEG_PLAYER_AUTO, i, telegram_buf);
			}
		 /* send to previous slave holder */
	push_message(TELEG_PLAYER_AUTO, planet->slaved_to, telegram_buf);

		planet->slaved_to = 0;
		planet->is_sheep = 0;
	}

   } else {
	 /* add production to all people here */
	for (i=1; i<=Num_races; i++) {

	  if (planet->info[i-1].numsectsowned) {

	 	if (planet->info[i-1].fuel + prod_fuel[i-1] > 100000)
		  planet->info[i-1].fuel = 100000;
		else
		  planet->info[i-1].fuel += prod_fuel[i-1];

	 	if (planet->info[i-1].resource + prod_res[i-1] > 100000)
		  planet->info[i-1].resource = 100000;
		else
		  planet->info[i-1].resource += prod_res[i-1];

	 	if (planet->info[i-1].destruct + prod_destruct[i-1] > 100000)
		  planet->info[i-1].destruct = 100000;
		else
		  planet->info[i-1].destruct += prod_destruct[i-1];

 	   /* do tech investments */
 	  if (planet->info[i-1].resource >= planet->info[i-1].tech_invest) {
 		races[i-1]->tech += 
 		   log10(1.0+(double)planet->info[i-1].tech_invest) * TECH_INVEST;
 		planet->info[i-1].resource -= planet->info[i-1].tech_invest;
 	  }

	   /* build wc's if it's been ordered */
	  if (planet->info[i-1].tox_thresh>0 &&
	      planet->conditions[TOXIC] >= planet->info[i-1].tox_thresh &&
	      planet->info[i-1].resource >= Shipdata[OTYPE_TOXWC][ABIL_COST]) {
	          shiptype *s2; reg int t;
		++Num_ships;
		ships = (shiptype **)realloc(ships, (unsigned)((Num_ships+1)*sizeof(shiptype*)));
		s2 = ships[Num_ships] = Malloc(shiptype);
/*		printf("planet /%s/%s made Tox wc #%d.\n",Stars[starnum]->name,
			Stars[starnum]->pnames[planetnum],Num_ships); */
		bzero((char *)s2,sizeof(shiptype));
		s2->type = OTYPE_TOXWC;

		s2->armor = Shipdata[OTYPE_TOXWC][ABIL_ARMOR];
		s2->guns = Shipdata[OTYPE_TOXWC][ABIL_GUNS];
		s2->size = Shipdata[OTYPE_TOXWC][ABIL_TARGET];
		s2->max_crew = Shipdata[OTYPE_TOXWC][ABIL_MAXCREW];
		s2->max_resource = Shipdata[OTYPE_TOXWC][ABIL_CARGO];
		s2->max_fuel = Shipdata[OTYPE_TOXWC][ABIL_FUELCAP];
		s2->max_destruct = Shipdata[OTYPE_TOXWC][ABIL_DESTCAP];
		s2->max_speed = Shipdata[OTYPE_TOXWC][ABIL_SPEED];
		s2->base_mass = getmass(s2);
		s2->mass = s2->base_mass;
 		s2->is_alive = 1;
		sprintf(s2->name,"Scum%04d",Num_ships);

		insert_sh_plan(planet,s2,Num_ships);

		s2->whatorbits = LEVEL_PLAN;
		s2->storbits = starnum;
		s2->pnumorbits = planetnum;
		s2->is_docked = 1;
		s2->xpos = int_rand(0,planet->Maxx-1);
		s2->ypos = int_rand(0,planet->Maxy-1);
		s2->whatdest = LEVEL_PLAN;
		s2->deststar = starnum;
		s2->destpnum = planetnum;
		s2->owner = i;
		t = MIN(TOXMAX,planet->conditions[TOXIC]);	/* amt of tox */
		planet->conditions[TOXIC] -= t;
		s2->object.number = t;
	}
     } 	/* (if numsectsowned[i]) */

   } /* (for i=1 to Num_races) */

  }  /* (else (if slaved_to)) */


   planet->is_sheep = 0;

 }

 for (i=1; i<=Num_races; i++) {
	Power[i-1].resource += planet->info[i-1].resource;
	Power[i-1].destruct += planet->info[i-1].destruct;
	Power[i-1].fuel += planet->info[i-1].fuel;
	Power[i-1].planets_owned += !!planet->info[i-1].numsectsowned;
	Power[i-1].sectors_owned += planet->info[i-1].numsectsowned;
/*	Power[i-1].sum_mob += avg_mob[i-1]; */
 }

check(planet,12);
 return allmod;
}


check(p,n)
planettype *p;
int n;
{
 if (p->sectormappos != Sectormappos)
	fprintf(stderr," WHOA! sectormappos %d != %d (%d)\n",
		p->sectormappos, Sectormappos, n);
 /*else
	fprintf(stderr, "OK (%d)\n",n);*/
}
